# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import shutil
import commands

class copying:
	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_position(gtk.WIN_POS_CENTER)
		self.window.set_title('Organic Photovoltaic Device Model (www.opvdm.com) - activation')
		#self.window.connect("delete_event", self.delete_event)
		#self.window.connect("destroy", self.destroy)
		self.window.set_border_width(10)
		box = gtk.VBox()
		label = gtk.Label()
		label.set_markup("<big><b>Organic photovoltaic device model</b>\n"+
				 "(<a href=\"http://www.opvdm.com\" "+
                         "title=\"Click to find out more\">www.opvdm.com</a>)\n\n"
				+"Dear User,\n\n"
				+"I distribute two versions of opvdm, an <b>open source version</b> which you can download at\n"
				+"<a href=\"http://www.opvdm.com\" title=\"Click to find out more\">www.opvdm.com</a> and a <b>closed source version</b> with more features.\n"
				+"It looks like you have the closed source version.\n"
				+"\nTo activate it do the following:\n"
				+"<b>1.</b> Click on the button below called \"Generate key\"\n"
				+"<b>2.</b> Save the license key file to your desktop (or somewhere else convenient)\n"
				+"<b>3.</b> Send key.dat to <a href=\"mailto:roderick.mackenzie\@nottingham.ac.uk\" >roderick.mackenzie@nottingham.ac.uk</a>\n"
				+"<b>4.</b> I will send you back an activation key.\n"
				+"<b>5.</b> Copy this key into your home directory.\n\n"
				+"Rod\n18/10/13\n"
				+"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n\n\n"
				+"</big>")
		box.add(label)

		label.show()


		button = gtk.Button("Generate key")
		button.connect("clicked", self.callback_gen_key, None)
		#self.button.connect_object("clicked", gtk.Widget.destroy, self.window)
		button.show()
		box.add(button)
		box.show()
		self.window.add(box)

	def wow(self,exe_command):
		self.exe_command=exe_command
		self.window.show()

	def callback_gen_key(self, widget, data=None):
		dialog = gtk.FileChooserDialog("Select directory to save the key to..",None,
		gtk.FILE_CHOOSER_ACTION_SAVE,
		(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
		gtk.STOCK_SAVE, gtk.RESPONSE_OK))
		dialog.set_default_response(gtk.RESPONSE_OK)

		dialog.set_action(gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)
		filter = gtk.FileFilter()
		filter.set_name("*.")
		filter.add_pattern("*.")
		dialog.add_filter(filter)

		response = dialog.run()
		if response == gtk.RESPONSE_OK:
			cmd = self.exe_command + ' --genkey-dir '+ dialog.get_filename()+'/'
			text='I have generated file '+str(dialog.get_filename())+'/key.dat.'
			ret= os.system(cmd)
			dialog.destroy()

			message = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, buttons=gtk.BUTTONS_OK)

			message.set_markup(text)
			message.run()
			message.destroy()

		elif response == gtk.RESPONSE_CANCEL:
			print 'Closed, no files selected'
		dialog.destroy()


