# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import pygtk
pygtk.require('2.0')
import gtk
import sys
import os
import shutil
from scan_item import scan_item
from scan_item import scan_item_add
from token_lib import tokens

class tab_class(gtk.Table):

	lines=[]
	edit_list=[]
	file_name=""
	line_number=[]
	name=""
	visible=1
	def callback_edit(self, widget, data=None):
		line=self.line_number[data]
		self.lines[line]=self.edit_list[data].get_text()
		self.edit_list[data].set_text(self.lines[line])
		print "Written data to", self.file_name
		a = open(self.file_name, "w")
		for i in range(0,len(self.lines)):
			a.write(self.lines[i]+"\n")
		a.close()


	def wow(self,filename,fullname,check_list):
		self.file_name=filename
		self.edit_list=[]
		self.line_number=[]
		print "loading ",filename

		f = open(filename)
		self.lines = f.readlines()
		f.close()
		pos=0
		for i in range(0, len(self.lines)):
			self.lines[i]=self.lines[i].rstrip()

		n=0
		pos=0
		my_token_lib=tokens()
		for i in range(0, len(self.lines)/2):

			show=False
			units="Units"
			out_text=self.lines[pos]
			result=my_token_lib.find(out_text)
			if result!=False:
				units=result.units
				text_info=result.info
				show=True
			pos=pos+1

			if show == True :

				label = gtk.Label()
				label.set_markup(text_info)
				label.set_use_markup(True)
				self.attach(label, 0, 1, n, n+1)
				label.show()

				self.line_number.append(pos)
				self.edit_list.append(gtk.Entry(max=0))
				self.edit_list[n].set_text(self.lines[pos]);
				self.attach(self.edit_list[n], 1, 2, n, n+1)
				self.edit_list[n].connect("changed", self.callback_edit, n)
				self.edit_list[n].show()
				#print "out -> %s %i",out_text,len(self.edit_list)

				label = gtk.Label()
				label.set_markup(units)
				label.set_use_markup(True)
				label.show()
				self.attach(label, 2, 3, n, n+1,gtk.SHRINK,gtk.SHRINK)
				self.set_col_spacing(3, 5)
				self.set_col_spacing(2, 5)
				label.show()

				scan_item_add(check_list,filename,out_text,text_info)

				n=n+1

			pos=pos+1

